proc sql;
	delete from CONTROL.PARAMETER_LIST_CREDIT_SCORING 
	where JOB_NM in ("AM_EXT_ABT_FW.sas", "ANALYTICAL_MODEL_PRE_DIM.sas","ANALYTICAL_MODEL_DIM.sas");
quit;	

proc sql;

	update control.PARAMETER_LIST_CREDIT_SCORING
	set LEVEL_NO = LEVEL_NO + 1;
quit;

proc sql;
	insert into control.PARAMETER_LIST_CREDIT_SCORING (JOB_NM,LEVEL_NO,RETURN_CD)	
	VALUES ("CAS_EXT_CSAM.sas",1,.)	
	VALUES ("APS_EXT_CSAM.sas",1,.)
	VALUES ("ACCOUNT_SCORE_PRE_DETAIL.sas",2,.)
	VALUES ("ACCOUNT_SCORE_DETAIL.sas",3,.)
	VALUES ("APPLICATION_SCORE_PRE_DETAIL.sas",2,.)
	VALUES ("APPLICATION_SCORE_DETAIL.sas",3,.);
	
quit;

proc sql;	
	update control.PARAMETER_LIST_CREDIT_SCORING
	set LEVEL_NO = LEVEL_NO + 4
	where LEVEL_NO >= 21;
quit;

proc sql;	
	update control.PARAMETER_LIST_CREDIT_SCORING
	set LEVEL_NO = 21
	where kleft(kright(JOB_NM)) = "SCORE_CARD_VARIABLE_FACT_PDO_DEVY.sas";
quit;

proc sql;	
	update control.PARAMETER_LIST_CREDIT_SCORING
	set LEVEL_NO = 22
	where kleft(kright(JOB_NM)) = "SCORE_CARD_VARIABLE_FACT_PDO_DEVN.sas";
quit;

proc sql;
	insert into control.PARAMETER_LIST_CREDIT_SCORING (JOB_NM,LEVEL_NO,RETURN_CD)	
	VALUES ("SCORE_CARD_VARIABLE_FACT_PDA_DEVY.sas",23,.)
	VALUES ("SCORE_CARD_VARIABLE_FACT_PDA_DEVN.sas",24,.);
quit;