/**
 * <p>Title: cProcessTree</p>
 * <p>Description: Class to get Tree up to parent level</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Ajit Singh
 * @version 1.0
 */
package com.sas.metadata.imp;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Vector;

import com.sas.metadata.AssociationList;
import com.sas.metadata.CMetadata;
import com.sas.metadata.MdException;
import com.sas.metadata.MdObjectFactory;
import com.sas.metadata.MdObjectStore;
import com.sas.metadata.MetadataUtil;
import com.sas.metadata.Tree;

/**
 * @author sinajs
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class cProcessTree {
	
	static HashMap m_hmTrees = new HashMap();

	protected static String processTree(CMetadata tr){
		StringBuffer sb = new StringBuffer(500);
		sb.append(tr.getName());
		
		if(m_hmTrees.containsKey(tr.getId()))
		{
			return (String)m_hmTrees.get(tr.getId());
		}
		else
		{
		
		if(!"ETL Studio Custom Tree".equalsIgnoreCase(tr.getName())
				&& !"SAS Data Integration Studio Custom Tree".equalsIgnoreCase(tr.getName())){
 			Tree tr1=null;
 			MdObjectStore mdobjectstore2 = MdObjectFactory.createObjectStore();

			for(int allTree=0;allTree<30;allTree++){
					if(allTree ==0){
						tr1 = getMyParentTree(tr, mdobjectstore2);
					}else{
						tr1 = getMyParentTree(tr1, mdobjectstore2);
					}

					try {						
						String s = tr1.getName();
						if(tr1.getParentTree() != null){
							tr1 = tr1.getParentTree();
							if(!"ETL Studio Custom Tree".equalsIgnoreCase(tr1.getName())
									&& !"SAS Data Integration Studio Custom Tree".equalsIgnoreCase(tr1.getName())){
								sb.append("=="+tr1.getName());
							}else{
								
								break;
							}
							
						}
					} catch (MdException e) {
						e.printStackTrace(System.err);
					} catch(Exception e){
						a.error(e.getMessage());
						e.printStackTrace(System.err);
						cUtilityClass.WriteLog("ERROR: "+e.getMessage());	
					}
				}
			mdobjectstore2.dispose();
		}
		m_hmTrees.put(tr.getId(), sb.toString());
	return new String(sb);
    }
	
} 
    private static Tree getMyParentTree(CMetadata tr, MdObjectStore mdobjectstore2){
	
		CMetadata cm3=null;
		try {
			//MdObjectStore mdobjectstore2 = MdObjectFactory.createObjectStore();
			mdobjectstore2.setIsObjectCopiedFromParentOnCreation(false);
			tr = MdObjectFactory.createComplexMetadataObject(mdobjectstore2, tr);
			cm3 = MetadataUtil.getMetadataAllDepths(tr,
					new ArrayList(),
					new ArrayList(),
					"<Templates><Tree> <ParentTree/> </Tree> <Tree/> </Templates>",
					0x8018c); 
		} catch (MdException e) {
			a.error(e.getMessage());
			e.printStackTrace(System.err);
			cUtilityClass.WriteLog("ERROR: "+e.getMessage());	
		
		}catch(Exception e){
			a.error(e.getMessage());
			e.printStackTrace(System.err);
			cUtilityClass.WriteLog("ERROR: "+e.getMessage());	
		}
		return (Tree)cm3;
	}
   
    protected static HashMap getInfoMapsTree(String reposId, String type){
		MdObjectStore myStore = MdObjectFactory.createObjectStore();
		String check = "";
		
		String XMLSelect =""; 
			if("Map".equalsIgnoreCase(type)){
				check="ReportStudio";
				XMLSelect = "<XMLSelect search=\"Tree[@Name='Maps']\"/>";	
			}
			if("Report".equalsIgnoreCase(type)){
				check="Shared";
				XMLSelect = "<XMLSelect search=\"Tree[@Name='Reports']\"/>";	
			}
			
			
		List Objects = null;
		Tree mapTree =null;
		HashMap hmTreeMap=new HashMap(); 
		boolean subTreeBreak=true;
		List treeList = new Vector();
		try {
			Objects = (MetadataUtil.getMetadataObjectsSubset(myStore, reposId,
					"Tree", MetadataUtil.OMI_TEMPLATE |MetadataUtil.OMI_XMLSELECT
							| MetadataUtil.OMI_GET_METADATA, XMLSelect));
			if(Objects.size()>0){
				for(int j=0;j<Objects.size();j++){
					mapTree = (Tree)Objects.get(j);
					if(check.equalsIgnoreCase(mapTree.getParentTree().getName()))
						break;
					}// end of for loop
				
				Tree tr1=null;
				treeList.add(mapTree);
				for(int u=0;u<1;u++){
					treeList = doSomething(treeList);
				}
				for(int v=0;v<treeList.size();v++){
					Tree tr3 = (Tree)treeList.get(v);
					String s = processMapTree(tr3,"ReportStudio");
					hmTreeMap.put(s.toLowerCase(),tr3);
				}
			  }// end of if
			} catch (MdException e) {
				a.errorMessage(e.getMessage(), "ERROR in export of InfoMaps" );
				e.printStackTrace(System.err);
				cUtilityClass.WriteLog("ERROR: in export of InfoMaps" + e.getMessage());
		}catch (Exception e) {
			a.errorMessage(e.getMessage(), "ERROR in export of InfoMaps" );
			e.printStackTrace(System.err);
			cUtilityClass.WriteLog("ERROR: in export of InfoMaps" + e.getMessage());
		}
		return hmTreeMap;
	}// end of getInfoMaps

    private static List doSomething(List treeList){
			for(int w=0;w<treeList.size();w++){
			Tree myTree = (Tree)MdObjectFactory.createComplexMetadataObject(MdObjectFactory.createObjectStore(),(Tree)treeList.get(w));
			try {
				myTree = (Tree)MetadataUtil.getMetadataAllDepths(myTree,
						new ArrayList(),
						new ArrayList(),
						"<Templates><Tree> <ParentTree/> </Tree> <Tree/> </Templates>",
						0x8018c);
			} catch (MdException e) {
				a.errorMessage(e.getMessage(), "ERROR in export of InfoMaps" );
				e.printStackTrace(System.err);
				cUtilityClass.WriteLog("ERROR: in export of InfoMaps" + e.getMessage());
			}catch (Exception e) {
				a.errorMessage(e.getMessage(), "ERROR in export of InfoMaps" );
				e.printStackTrace(System.err);
				cUtilityClass.WriteLog("ERROR: in export of InfoMaps" + e.getMessage());
			}
			AssociationList alMapTrees = getAssociation(myTree);
			for(int g=0;g<alMapTrees.size();g++){
				Tree trTemp = (Tree)alMapTrees.get(g);
				treeList.add(trTemp);
			}	
		}
	return treeList;
	}
    
    private static AssociationList getAssociation(Tree tempTree){
		AssociationList al = null;
		try {
			al=tempTree.getSubTrees();
		} catch (MdException e) {
			e.printStackTrace(System.err);
		}
	return al;
	}// end of getAssociation
    
    
    protected static String processMapTree(CMetadata tr,String str){
		StringBuffer sb = new StringBuffer(500);
		if(!str.equalsIgnoreCase(tr.getName())){
			sb.append(tr.getName());
			Tree tr1=null;
			MdObjectStore mdobjectstore2 = MdObjectFactory.createObjectStore();

			for(int allTree=0;allTree<30;allTree++){
					if(allTree ==0){
						tr1 = getMyParentTree(tr, mdobjectstore2);
					}else{
						tr1 = getMyParentTree(tr1, mdobjectstore2);
					}

					try {
						if(tr1.getParentTree() != null){
						tr1 = tr1.getParentTree();
						}else{
							str = tr1.getName();
						}
						if(tr1 != null){
							String s = tr1.getName();
							if(!s.equalsIgnoreCase(str)){
								sb.append("=="+s);	
							}else {
								break;
							}		
						}
					} catch (MdException e) {
						a.errorMessage( e.getMessage(), "ERROR in Getting Tree Info");
						e.printStackTrace(System.err);
						cUtilityClass.WriteLog("ERROR: in Getting Tree Info :" + e.getMessage());
					} catch (Exception e) {
						a.errorMessage( e.getMessage(), "ERROR in Getting Tree Info");
						e.printStackTrace(System.err);
						cUtilityClass.WriteLog("ERROR: in Getting Tree Info :" + e.getMessage());
					}
				}		
			mdobjectstore2.dispose();
		}
	return sb.toString();
    }
    
    
	protected static List getTreeInfoObjects(String objTypes, String reposid,String XMLSelect) {
		MdObjectStore myStore = MdObjectFactory.createObjectStore();
		List Objects = null;
		try {
			Objects = (MetadataUtil.getMetadataObjectsSubset(myStore, reposid,
					objTypes, MetadataUtil.OMI_TEMPLATE |MetadataUtil.OMI_XMLSELECT
							| MetadataUtil.OMI_GET_METADATA, XMLSelect));
		
		} catch (MdException e) {
			// TODO Auto-generated catch block
			e.printStackTrace(System.err);
		}
		return Objects;
	}

}
