%macro check_alldefaults_nodefaults(input_ds, var_tot_acc,var_no_bads, ERROR_CODE);
%let Flag=;

	proc sql noprint;
		select count(*) into :var_cnts from &input_ds;

		select Sum(&var_no_bads), Sum(&var_tot_acc) into :Total_bads, :Total_Acc from &input_ds;
	quit;
%let Total_bads=&Total_bads.;
%let Total_Acc=&Total_Acc.;
/*CS4.3 HF2 */
/*New condition is added if the total bads is missing.*/
	%if( %sysevalf(&Total_bads)=0 or &Total_bads=. )%then 
		%let &ERROR_CODE = 'NO_DEFAULTS';
	%else 
	%do;
		%if (%sysevalf(&Total_Acc - &Total_bads)=0)%then 
			%let &ERROR_CODE = 'ALL_DEFAULTS';
		%else
			%let &ERROR_CODE = 'NONE';
	%end;

	 
%mend check_alldefaults_nodefaults;
