%global category scat vname vshortname vdesc vgroup aggtab aggvar aggtkey level category scat
	table_cat table_key noofjobs;
%let lib=analytic;

%select_abt_vars_screen_links;

/* Setting output library based on the debug flag */
%let out_lib=;
%debug_lib_path;

proc sql;
create table &out_lib..aggtabkeys as select distinct AGG_TABLE_KEY from &lib..var_master
where kupcase(VAR_CATEGORY)=kupcase("&category") and kupcase(VAR_SUB_CATEGORY)=kupcase("&scat");
create table &out_lib..vargroup as select distinct VAR_GROUP from &lib..var_master 
where kupcase(VAR_CATEGORY)=kupcase("&category") and kupcase(VAR_SUB_CATEGORY)=kupcase("&scat");
quit;

data _null_;
file _webout &webout_options;
	put '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
	put '<html xmlns="http://www.w3.org/1999/xhtml"><!-- InstanceBegin template="/Templates/dashboard.dwt" codeOutsideHTMLIsLocked="false" -->';
	put '  <head>';
	put '    <meta http-equiv="content-type" content="text/html;charset=utf-8" />';
	  /*I18N-scnjih-20080429-1541*/
	/*put '    <!-- InstanceBeginEditable name="doctitle" --><title>Layout</title><!-- InstanceEndEditable -->';*/
		put '    <!-- InstanceBeginEditable name="doctitle" --><title>'@;
		put "%sysfunc(sasmsg(smd_ds.bismsg,title_of_layout.1, noquote))"@;
		put '</title><!-- InstanceEndEditable -->';
	
	 /*I18N-scnjih-20080429-1541*/
	put '    <link rel="stylesheet" type="text/css" href="/SASABTFramework/styles/default.css" />';

	/* External scripts */
	put '    <script src="/SASABTFramework/javascript/scripts.js" type="text/javascript"></script>';
	put '    <script src="/SASABTFramework/javascript/buttonMenu.js" type="text/javascript"></script>';
	put '    <script src="/SASABTFramework/javascript/overlib.js" type="text/javascript"></script>';
	put '    <script type="text/javascript" src="/SASABTFramework/javascript/table_controls.js"></script>';
	put '    <script type="text/javascript" src="/SASABTFramework/javascript/boxOver.js"></script>';
	put '	 <script language="JavaScript" src="/SASABTFramework/javascript/editable_combo.js"></script>';
	put '    <script type="text/javascript">';
	put '    <!--';
	
	put 'function Savevar()';	
	put '{';
	put 'if(form1.vname.value=="")';
	put '{';
	put '	alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_prvdallval.1, noquote))"@;
	put '");';
	put '	return;';
	put '}';
	put 'if(form1.vshortname.value=="")';
	put '{';
	put '	alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_prvdallval.1, noquote))"@;
	put '");';
	put '	return;';
	put '}';
	put 'if(form1.vdesc.value=="")'@;
	put '{';
	put '	alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_prvdallval.1, noquote))"@;
	put '");';
	put '	return;';
	put '}';
	put 'if(form1.aggtab.value=="")'@; 
	put '{';
	put '	alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_prvdallval.1, noquote))"@;
	put '");';
	put '	return;';
	put '}';
	put 'if(form1.aggvar.value=="")'@;
	put '{';
	put '	alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_prvdallval.1, noquote))"@;
	put '");';
	put '	return;';
	put '}';
	put 'var x=document.getElementById("vgroup");';
	put 'if(x.options[x.selectedIndex].text=="Select a group"||'@;
	put 'x.options[x.selectedIndex].text=="")'@;
	put '{';
	put '	alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_prvdallval.1, noquote))"@;
	put '");';
	put '	return;';
	put '}';
	put 'var y=document.getElementById("aggtkey");';
	put 'if(y.options[y.selectedIndex].text=="Select a key"||'@;
	put 'y.options[y.selectedIndex].text=="")'@;
	put '{';
	put '	alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_prvdallval.1, noquote))"@;
	put '");';
	put '	return;';
	put '}';
	put 'if(document.getElementById("level").selectedIndex==0)'@;
	put '{';
	put '	alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_prvdallval.1, noquote))"@;
	put '");';
	put '	return;';
	put '}';
	put 'if(document.getElementById("table_cat").selectedIndex==0)'@;
	put '{';
	put '	alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_prvdallval.1, noquote))"@;
	put '");';
	put '	return;';
	put '}';
	put 'if(document.getElementById("table_key").selectedIndex==0)'@;
	put '{';
	put '	alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_prvdallval.1, noquote))"@;
	put '");';
	put '	return;';
	put '}';
	put 'if(document.getElementById("lftflg").selectedIndex==0)'@;
	put '{';
	put '	alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_prvdallval.1, noquote))"@;
	put '");';
	put '	return;';
	put '}';
	put 'if(form1.noofjobs.value=="")'@;
	put '{';
	put '	alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_prvdallval.1, noquote))"@;
	put '");';
	put '	return;';
	put '}';
	put 'if(chkchars(form1.vname.value)==false)';
		put 'return;';
	put 'if(chkchars(form1.aggtab.value)==false)';
		put 'return;';
	put 'if(chkchars(form1.aggvar.value)==false)';
		put 'return;';
	put 'if(chkchars(y.options[y.selectedIndex].text)==false)';
		put 'return;';
	put 'var x=document.getElementById("vgroup");';
	put 'var txt=x.options[x.selectedIndex].text;';
	put 'if(txt.length>80)';
	put '{alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_msg80pchars.1, noquote))"@;
	put '");return;}';
	put 'var x=document.getElementById("aggtkey");';
	put 'var txt=x.options[x.selectedIndex].text;';
	put 'if(txt.length>32)';
	put '{alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_msg32pchars.1, noquote))"@;
	put '");return;}';	
	put "form1._program.value=&JOB_DETAILS;";
	put 'form1.submit();';
	put '}';
                   
	put 'function Canceladd()';	
	put '{';
	put "form1._program.value=&DISPLAY_VAR;";
	put 'form1.submit();';
	put '}';

	put 'function chkchars(obj)';
	put '{';
	put 'if(obj.charCodeAt(0)>=48 && obj.charCodeAt(0)<=57)';
	put '{alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.msgnumbeg.1, noquote))"@;
	put '");return false;}';
	put 'for(var i=0;i<obj.length;i++)';
	put '{';
	put 'if(obj.charCodeAt(i)!=95 && (obj.charCodeAt(i)<48||obj.charCodeAt(i)>57)'@;
	put '&& (obj.charCodeAt(i)<97||obj.charCodeAt(i)>122) && (obj.charCodeAt(i)<65||obj.charCodeAt(i)>90))';	
	put '{obj.value="";';
	put 'alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.msgspchrs.1, noquote))"@;/* CS4.3 HF2 */ 
	put '");';
	put 'return false;}';
	put '}';
	put '}';

	put 'function validate_tabcol(obj,evt)';
	put '{';
	put 'var e = event || evt;';
	put 'var charCode = e.which || e.keyCode;';
	put 'if (charCode != 95 && (charCode < 48 || charCode > 57) && (charCode < 97 || charCode > 122) && (charCode < 65 || charCode > 90))';
	put '{';
		put '	return false;';
	put '}';
	put 'return true;';
	put '}';

	put '    -->';
	put '    </script>';
	put '  </head>';
	put '  <body>';

	put '<form name="form1" action="/SASStoredProcess/do" method="post">';
	put '<input type="hidden" name="_program" value="">';

	c=symget('category');
	x1 = '<input type="hidden" name="category" value="'||strip(c)||'">';
	put x1;
	
	sc=symget('scat');
	x2 = '<input type="hidden" name="scat" value="'||strip(sc)||'">';
	put x2;	

	put '<table border="0"><tr><td></td><td>';
	put '<table class="tableview" cellpadding="0">';
	put '<tr>';
	put "<th class=""tabletextcol"">" @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.var_category.1, noquote))"@;
	put "</th><td class=""tabletextcol"">&category</td>";
	put '</tr><tr>';
	put "<th class=""tabletextcol"">" @;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.var_subcategory.1, noquote))"@;
	put "</th><td class=""tabletextcol"">&scat</td>";
	put '</tr>';
	put '</table>';
	put '</td>';
	put '<td></td></table>';

	put '<table border="0" width="100%"><tr><td></td><td>';
	put '<table width="100%" class="tableview" border="0" class="tableborder" cellpadding="3" cellspacing="0">';
	put '<tr class="tableoddrow" tr valign="top"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_variable_name.1, noquote))"@;
	put '</b></td>'@;
	put '<td><input type="text" name="vname" value="'@;
	put "&vname"@;
	put '" maxlength="32" style="width:250px;" onkeypress="return validate_tabcol(this);"></td>';
	put '</tr>';
	put '<tr class="tableevenrow" tr valign="top"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_variable_short_name.1, noquote))"@;
	put '</b></td>';
	put '<td><input type="text" name="vshortname" maxlength="125" value="'@;
	put "&vshortname"@;
	put '" style="width:250px;"></td></tr>';
	put '<tr class="tableoddrow" tr valign="top"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_variable_desc.1, noquote))"@;
	put '</b></td>';
	put '<td><input type="text" name="vdesc" maxlength="1200" value="'@;
	put "&vdesc"@;
	put '" style="width:250px;"></td></tr>';
	put '<tr class="tableevenrow" tr valign="top"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_variable_group.1, noquote))"@;
	put '</b></td>';
	put '<td><SELECT name="vgroup" id="vgroup"'; 
	put 'style="width:250px;" onKeyDown="fnKeyDownHandler(this, event);" onKeyUp="fnKeyUpHandler_A(this, event); return false;" onKeyPress = "return fnKeyPressHandler_A(this, event);"  onChange="fnChangeHandler_A(this, event);">';
	put '<option>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_select_group.1, noquote))"@;
	put '</option>';
run;
data _null_;
file _webout &webout_options;
set &out_lib..vargroup;
put '<option'@;
if var_group = ktrim(kleft("&vgroup")) then
	put ' selected'@;
put '>'@;
put var_group@; 
put '</option>'@;
run;
data _null_;
file _webout &webout_options;
	put '</SELECT> ' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.editable.1, noquote))"@;
	put '</td></tr>';
	put '<tr class="tableoddrow" tr valign="top"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_aggtabname.1, noquote))"@;
	put '</b></td>';
	put '<td><input type="text" name="aggtab" value="'@;
	put "&aggtab"@;
	put '" maxlength="32" style="width:250px;" onkeypress="return validate_tabcol(this);"></td></tr>';
	put '<tr class="tableevenrow" tr valign="top"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_aggvarname.1, noquote))"@;
	put '</b></td>';
	put '<td><input type="text" name="aggvar" value="'@;
	put "&aggvar"@;
	put '" maxlength="32" style="width:250px;" onkeypress="return validate_tabcol(this);"></td></tr>';
	put '<tr class="tableoddrow" tr valign="top"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_aggtabkey.1, noquote))"@;
	put '</b></td>';
	put '<td><SELECT name="aggtkey" id="aggtkey"'; 
	put 'style="width:250px;" onKeyDown="fnKeyDownHandler(this, event);" onKeyUp="fnKeyUpHandler_A(this, event); return false;" onKeyPress = "return fnKeyPressHandler_A(this, event);"  onChange="fnChangeHandler_A(this, event);">';
	put '<option>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_select_key.1, noquote))"@;
	put '</option>';
run;
data _null_;
file _webout &webout_options;
set &out_lib..aggtabkeys;
	put '<option'@; 
	if agg_table_key = ktrim(kleft("&aggtkey")) then
		put ' selected'@;
	put '>'@;
	put agg_table_key@;
	put '</option>'@;
run;
data _null_;
file _webout &webout_options;
	put '</SELECT> ' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.editable.1, noquote))"@;
	put '</td></tr>';
	put '<tr class="tableevenrow" tr valign="top"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_levelno.1, noquote))"@;
	put '</b></td>';
	put '<td><SELECT name="level" style="width:250px;">';
	/*I18N-scnjih-20080424-0928*/
	/*put '<option>Select a level no.</option>';*/
	put '<option>'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,add_var.sas.1, noquote))"@;
	put '</option>';
	
	/*I18N-scnjih-20080424-0928*/
	put '<option'@;
	if ktrim(kleft("&level")) eq "1" then
		put ' selected'@;
	put '>1</option>';
	put '<option'@;
	if ktrim(kleft("&level")) eq "2" then
		put ' selected'@;
	put '>2</option>';
	put '<option'@;
	if ktrim(kleft("&level")) eq "3" then
		put ' selected'@;
	put '>3</option>';
	put '</SELECT></td></tr>';
	put '<tr class="tableoddrow" tr valign="top"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_tablecat.1, noquote))"@;
	put '</b></td>';
	put '<td><SELECT name="table_cat" style="width:250px;" >';
	put '<option>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_select_tablecat.1, noquote))"@;
	put '</option>';
	put '<option'@;
	if ktrim(kleft("&table_cat")) eq "ACCOUNT" then
		put ' selected'@;
	put '>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_opt_account.1, noquote))"@;
	put '</option>';
	put '<option'@;
	if ktrim(kleft("&table_cat")) eq "APPL" then
		put ' selected'@;
	put '>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_opt_appl.1, noquote))"@;
	put '</option>';
	put '<option'@;
	if ktrim(kleft("&table_cat")) eq "APPT" then
		put ' selected'@;
	put '>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_opt_appt.1, noquote))"@;
	put '</option>';
	put '<option'@;
	if ktrim(kleft("&table_cat")) eq "CUSTOMER" then
		put ' selected'@;
	put '>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_opt_cust.1, noquote))"@;
	put '</option>';
	put '</SELECT></td></tr>';
	put '<tr class="tableevenrow" tr valign="top"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_tablekey.1, noquote))"@;
	put '</b></td>';
	put '<td><SELECT name="table_key" style="width:250px;">';
	put '<option>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_select_tabkey.1, noquote))"@;
	put '</option>';
	put '<option'@;
	if ktrim(kleft("&table_key")) eq "ACCOUNT_RK" then
		put ' selected'@;
	put '>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_account_rk.1, noquote))"@;
	put '</option>';
	put '<option'@;
	if ktrim(kleft("&table_key")) eq "APPLICATION_RK" then
		put ' selected'@;
	put '>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_application_rk.1, noquote))"@;
	put '</option>';
	put '<option'@;
	if ktrim(kleft("&table_key")) eq "APPLICANT_RK" then
		put ' selected'@;
	put '>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_applicant_rk.1, noquote))"@;
	put '</option>';
	put '<option'@;
	if ktrim(kleft("&table_key")) eq "CUSTOMER_RK" then
		put ' selected'@;
	put '>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_customer_rk.1, noquote))"@;
	put '</option>';
	put '</SELECT></td></tr>';
	put '<tr class="tableoddrow" tr valign="top"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_leftflag.1, noquote))"@;
	put '</b></td>';
	put '<td><SELECT name="lftflg" style="width:250px;">';
	put '<option>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.select_flag.1, noquote))"@;
	put '</option>';
	put '<option'@;
	if ktrim(kleft("&lftflg")) eq "Y" then
		put ' selected'@;
	put '>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.flag_yes.1, noquote))"@;
	put '</option>';
	put '<option'@;
	if ktrim(kleft("&lftflg")) eq "N" then
		put ' selected'@;
	put '>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.flag_no.1, noquote))"@;
	put '</option>';
	put '</td></tr>';
	put '<tr class="tableevenrow" tr valign="top"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.add_var_noofjobs.1, noquote))"@;
	put '</b></td>';
	put '<td><input type="text" name="noofjobs" value="'@; 
	put "&noofjobs"@;
	put '" maxlength="40" style="width:250px;"></td></tr>';
	put '</table>';
	put '</td></tr>'; 
	put '</table>';

	put '<table border="0" width="100%"><tr><td></td><td>';
	put '<table class="tableview" border="0" width="100%">';
	put '<tr><td class="tabletextcol">' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.editableddboxes.1, noquote))"@;
	put '</td></tr>';
	put '</table>';
	put '</td></tr></table>';

	put '<table border="0" width="100%"><tr><td></td><td>';
	put '<table border="0" class="tableview" cellpadding="3" cellspacing="0" summary="Action Buttons" id="dialogbuttons" width="100%">';
	put '<tr>';
	put '<td>';
	put '<input class="mmhide_btn" style="width:80px;" onmouseover="hov(this,''mmhide_btn mmhide_btnhov'')" onmouseout="hov(this,''mmhide_btn'')" value=" ' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.cancelbttn.1, noquote))"@;
	put '" name="Cancel" type="button" onclick="Canceladd()">';
	put '</td>';
	put '</td>';
	put '<td>';
	put '<input class="mmhide_btn" style="width:80px;" onmouseover="hov(this,''mmhide_btn mmhide_btnhov'')" onmouseout="hov(this,''mmhide_btn'')" value="' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.nextbttn.1, noquote))"@;
	put ' " name="Next" type="button" onclick="Savevar()">';
	put '</td>';
	put '</tr>';
	put '</table>';
	put '</td></tr></table>';
	put '</body>';
	put '</html>';
run;
