%let js_path=../ABTFramework/;
%let js_path = "&js_path.script/tree_items.js";

/* Alias for the back-end library */
%let lib=analytic;

/* Setting output library based on the debug flag */
%let out_lib=;
%debug_lib_path;

proc sql;
create table &out_lib..varcat as select distinct var_category from &lib..var_master;
create table &out_lib..varcatsub as 
	select distinct varcat.var_category, var_sub_category 
	from &lib..var_master, &out_lib..varcat
	where var_master.var_category = varcat.var_category;
quit;

%macro subcat(cat);
		data &out_lib..tmp;
		set &out_lib..varcatsub;
			where kupcase(ktrim(kleft(var_category)))=kupcase("&cat");
		run;

		data _null_;
		set &out_lib..tmp end=last;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
			file &js_path &webout_options mod lrecl=700; /* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
			put "	['&fonttag1"@;
			put var_sub_category@;
			put "&fonttag2','"@;
			put "http://&_SRVNAME:&_SRVPORT/SASStoredProcess/do?"@;
			put '_program='@;
			put "SBIP://Foundation/BIS/analytics/explore_abt/disp_var&category="@;
			vcat = strip(urlencode(unicodec(var_category,'utf8')));
			put vcat@; 
			put '&scat='@;
			vsubcat = strip(urlencode(unicodec(var_sub_category,'utf8')));
			put vsubcat@; 
			put "'],";
			if last then
				put "],";
		run;
%mend subcat;

%macro endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "],";
run;
%mend endsubcat;

%let fonttag1 = <font>;
%let fonttag2 = </font>;	

/* Creating a file pointer in write mode. If this is not done then the data 
in the file will be repeated with each hit to the page. */
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
 file &js_path &webout_options;
/*I18N-scnhuh-20080418-1955*/
run;
/* Opening the file in APPEND mode. */
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
	file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "var TREE_ITEMS = [['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_abtvariables.1, noquote))"@;
	put " &fonttag2','',";
run;

data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_customer.1, noquote))"@;
	put " &fonttag2',0,"; 
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_asset.1, noquote))"@;
	put " &fonttag2',0,";
	put " 	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_nrvcredit.1, noquote))"@;
	put " &fonttag2',0,";
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_ulncons.1, noquote))"@;
	put " &fonttag2',0,";
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_morlon.1, noquote))"@;
	put " &fonttag2',0,";
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_morlon.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_ulncons.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_morslncons.1, noquote))"@;
	put " &fonttag2',0,";
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_morslncons.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_nrvcredit.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_ccdcons.1, noquote))"@;
	put " &fonttag2',0,";
run;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_ccd.1, noquote))"@;
	put " &fonttag2',0,";
run;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_ccd.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_ccdcons.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_asset.1, noquote)));
run;
%endsubcat;

data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_liability.1, noquote))"@;
	put " &fonttag2',0,";
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_dmdliability.1, noquote))"@;
	put " &fonttag2',0,";
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_chkcons.1, noquote))"@;
	put " &fonttag2',0,";
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_ovdcons.1, noquote))"@;
	put " &fonttag2',0,";
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_ovdcons.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_chkcons.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_savcons.1, noquote))"@;
	put " &fonttag2',0,";
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_chknsavs.1, noquote))"@;
	put " &fonttag2',0,";
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_overdraft.1, noquote))"@;
	put " &fonttag2',0,";
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_overdraft.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_chknsavs.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_savcons.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_dmdliability.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_termliability.1, noquote))"@;
	put " &fonttag2',0,";
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_cdcons.1, noquote))"@;
	put " &fonttag2',0,";
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_cdrecdep.1, noquote))"@;
	put " &fonttag2',0,";
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_cdrecdep.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_cdcons.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_rdcons.1, noquote))"@;
	put " &fonttag2',0,";
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_rdcons.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_termliability.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_liability.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "	['&fonttag1." @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_subcat.1, noquote))"@;
	put " &fonttag2',0,";	
	%subcat(%sysfunc(sasmsg(smd_ds.bismsg,abt.expabt_customer.1, noquote)));
run;
%endsubcat;
data _null_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
file &js_path &webout_options mod lrecl=700;/* CS4.3 HF2 */ 
/*I18N-scnhuh-20080418-1955*/
	put "]];";
run;

data _NULL_;
/*I18N-scnhuh-20080418-1955*/
/*add &webout_options*/
	file _webout &webout_options;
/*I18N-scnhuh-20080418-1955*/
	put '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
	put '<html xmlns="http://www.w3.org/1999/xhtml"><!-- InstanceBegin template="/Templates/dashboard.dwt" codeOutsideHTMLIsLocked="false" -->';
	put '  <head>';
	put '    <meta http-equiv="content-type" content="text/html;charset=utf-8" />';
	  /*I18N-scnjih-20080429-1545*/
	/*put '    <!-- InstanceBeginEditable name="doctitle" --><title>Layout</title><!-- InstanceEndEditable -->';*/
		put '    <!-- InstanceBeginEditable name="doctitle" --><title>'@;
		put "%sysfunc(sasmsg(smd_ds.bismsg,title_of_layout.1, noquote))"@;
		put '</title><!-- InstanceEndEditable -->';
	
	 /*I18N-scnjih-20080429-1545*/
	put '    <link rel="stylesheet" type="text/css" href="/SASABTFramework/styles/default.css" />';
	put '<style type="text/css">';
	put 'a {text-decoration: none}';
	put 'font {color: rgb(0,0,0);font-size: 10pt}';
	put 'body {background-color: #faf8ed}';
	put '</style>';
	put '</head> ';
	put '<body bottommargin="0" topmargin="0" leftmargin="0" rightmargin="0" marginheight="0" marginwidth="0"> ';
	put '<script language="JavaScript" src="/SASABTFramework/script/tree.js"></script> ';
	put '<script language="JavaScript" src="/SASABTFramework/script/tree_items.js"></script> ';
	put '<script language="JavaScript" src="/SASABTFramework/script/tree_tpl.js"></script> ';
	
	put '<table cellpadding="0" cellspacing="0" border="0" width="100%">';
	put '<tr> ';
	put '	<td class="LabelFont"> ';
	put '	<script language="JavaScript"> ';
	put '	<!--// ';
	put '		new tree (TREE_ITEMS,TREE_TPL); ';
	put '	//--> ';
	put '	</script> ';
	put '	</td> ';
	put '</tr> ';
	put '</table> ';
	put '</body> ';
	put '</html> ';
run;
